	page	132,63,1,1
	opt	rc
	title	'DSP56000 Interrupt Vector Table'

;************************************************************
;* INIT.ASM -- DSP56000 interrupt vector table		    *
;*							    *
;* Copyright (C) 1990 by Jarkko Vuori. All rights reserved. *
;* Author(s): J Vuori					    *
;* Modification(s):					    *
;************************************************************

	section Vector
	xref	start
	xref	ssi_ini,ssi_rec,ssi_rer,ssi_xmt,ssi_xer
	xref	sci_ini,sci_rec,sci_err,sci_xmt,sci_tim

	nolist
	include 'intequlc'
	list

; Reset vector
	org	p:i_reset
	jmp	start

; SWI interrupt
	org	p:i_swi
	jsr	cpu_swi

; SSI receive interrupt
	org	p:i_ssird
	jsr	ssi_rec

; SSI receive interrupt with errors
	org	p:i_ssirde
	jsr	ssi_rer

; SSI transmitter interrupt
	org	p:i_ssitd
	jsr	ssi_xmt

; SSI transmitter interrupt with errors
	org	p:i_ssitde
	jsr	ssi_xer

; SCI receive interrupt
	org	p:i_scird
	jsr	sci_rec

; SCI receive interrupt with errors
	org	p:i_scirde
	jsr	sci_err

; SCI transmitter interrupt
	org	p:i_scitd
	jsr	sci_xmt

; SCI timer
	org	p:i_scitm
	jsr	sci_tim

; Host xmitter interrupt
	org	p:i_hsttd
	jsr	host_x

	endsec


;****************************
;*  CONTEX STORE FOR INTS   *
;****************************

	section Contexts
	xdef	scix,scir,scit,ssir,ssix,hostx
	xdef	scixr,scirr,swir,hostxr

	nolist
	include 'macros'
	list

	org	l:

scix	roomab
scir	roomab
scit	roomab
ssix	roomab
ssir	roomab
hostx	roomab

	org	y:

scixr	roomr
scirr	roomr
swir	roomr
hostxr	roomr

	endsec

	end
