;************************************************************
;* MACROS.ASM -- General Purpose Macros 		    *
;*							    *
;* Copyright (C) 1990 by Jarkko Vuori. All rights reserved. *
;* Author(s): J Vuori					    *
;* Modification(s):					    *
;************************************************************

	xref	contexa,contexb

; DCD light handling
dcdon	macro
	bset	#$2,x:m_pcd
	endm
dcdoff	macro
	bclr	#$2,x:m_pcd
	endm

; PTT handling
ptton	macro
	bset	#$4,x:m_pcd
	endm
pttoff	macro
	bclr	#$4,x:m_pcd
	endm

; macro for immediate move
movi	macro	data,dest
	move		    #data,a1
	move		    a1,dest
	endm
movib	macro	data,dest
	move		    #data,b1
	move		    b1,dest
	endm


; macro for total ALU contex saving
stoab	macro	contex
	move		    x,l:<contex+0
	move		    y,l:<contex+1
	move		    a10,l:<contex+2
	move		    b10,l:<contex+3
	move		    a2,x:<contex+4
	move		    b2,y:<contex+4
	endm


; macro for total ALU contex restoring
rclab	macro	contex
	move		    l:<contex+0,x
	move		    l:<contex+1,y
	move		    l:<contex+2,a10
	move		    l:<contex+3,b10
	move		    x:<contex+4,a2
	move		    y:<contex+4,b2
	endm


; macro for  ALU contex space reserving
roomab	macro
	ds	5
	endm


; macro for address register contex saving
stor	macro	contex,rx,mx,nx
	move		    rx,y:<contex+0
	move		    mx,y:<contex+1
	move		    nx,y:<contex+2
	endm


; macro for a and x registers contex restoring
rclr	macro	contex,rx,mx,nx
	move		    y:<contex+0,rx
	move		    y:<contex+1,mx
	move		    y:<contex+2,nx
	endm


; macro for  a and x contex space reserving
roomr	macro
	ds	3
	endm


; macro for convolution
conv	macro	mode,n,xd,cf,acc
	clr	acc	    x:(xd)+,x0	y:(cf)+,y0
	rep	#n-1
	mac	x0,y0,acc   x:(xd)+,x0	y:(cf)+,y0
	if	mode
	macr	x0,y0,acc   (xd)-
	else
	macr	x0,y0,acc
	endif
	endm


; macro for debugging
bug	macro	value
	move	#value,a1
	swi
	endm


; macro for post mortem dump
dump	macro
	ori	#$03,mr

	jclr	#m_htde,x:m_hsr,*
	movep	#>1313,x:m_htx

	move	#0,r0
	move	#$ffff,m0
	move	#0,n0

	move	#512+4064-1,a1
	do	a1,dploop
	jclr	#m_htde,x:m_hsr,*
	movep	p:(r0)+,x:m_htx
dploop

	move	#0,r0
	do	#256+2048-1,dxloop
	jclr	#m_htde,x:m_hsr,*
	movep	x:(r0)+,x:m_htx
dxloop

	move	#0,r0
	do	#256+2048+1,dyloop
	jclr	#m_htde,x:m_hsr,*
	movep	y:(r0)+,x:m_htx
dyloop

	stop
	endm
