	page	132,63,1,1
	opt	rc
	title	'Modem Main module'

;************************************************************
;* MAIN.ASM -- KISS modem main module			    *
;*							    *
;* Copyright (C) 1990 by Jarkko Vuori. All rights reserved. *
;* Author(s): J Vuori					    *
;* Modification(s):					    *
;************************************************************

	section Main
	xref	ssi_ini,adc_ini
	xref	sci_ini,sci_rec
	xref	iniHDLC,getbit

	xdef	cpu_swi,host_x,start

	org	p:

	nolist
	include 'ioequlc'
	include 'macros'
	list


;****************************
;*    Software interrupt    *
;****************************
; mainly for debug purposes, a1 contains bug trap id
cpu_swi
	bset	#m_htie,x:m_hcr
	jcc	<cpu_sw1
	stor	swir,r0,m0,n0
	move		    y:<hbwptr,r0
	move		    #0,n0
	move		    #hbuflen-1,m0
	nop
	move		    a1,x:(r0)+
	move		    r0,y:<hbwptr
	rclr	swir,r0,m0,n0
	rti

cpu_sw1 movep		    a1,x:m_htx
	rti


;****************************
;*    Host xmit interrupt   *
;****************************
host_x
	stoab	hostx
	stor	hostxr,r0,m0,n0

	move		    y:<hbrptr,r0
	move		    #0,n0
	move		    #hbuflen-1,m0

; check if buffer empty
	move		    y:<hbwptr,a
	move		    r0,x0
	cmp	x0,a
	jeq	<hostx1

; no, put data out
	movep	x:(r0)+,x:m_htx
	move		    r0,y:<hbrptr
	jmp	<hostx2

; yes, shut down xmitter
hostx1	bclr	#m_htie,x:m_hcr

hostx2	rclab	hostx
	rclr	hostxr,r0,m0,n0
	rti


;****************************
;*   Start of the program   *
;****************************
; no wait states on external memory
start
	movep		    #$0000,x:m_bcr	    ; no wait states

; initialize modules and peripherals
	jsr	<ssi_ini
	jsr	<sci_ini
	jsr	<iniHDLC

; initialize debug system
	movi	hbuf,y:<hbrptr
	movi	hbuf,y:<hbwptr

; initialize port C
	IF !DEBUG
	movep		    #$01eb,x:m_pcc	    ; TXD,RXD,SC0,SC2,SCK,SRD,STD
	ELSE
	movep		    #$01fb,x:m_pcc	    ; TXD,RXD,SC0,SC2,SCK,SRD,STD
	ENDIF
	movep		    #$0014,x:m_pcddr	    ; SCLK,SC1 as output
	movep		    #$0000,x:m_pcd

	IF !DEBUG
	jsr	<adc_ini
	ENDIF

; start interrupts
	movep		    #$b400,x:m_ipr	    ; SSI=IPL2,SCI=IPL1,HOST=IPL0
	andi	#$fc,mr 			    ; unmask interrupts


; *** main loop **

loop	wait
	jmp	<loop

	org	x:
hbuflen equ	1024
hbuf	ds	hbuflen

	org	y:
hbwptr	ds	1
hbrptr	ds	1

	endsec

	end
