	page	132,63,1,1
	opt	rc
	title	'CPFSK Modem Persistence Algorithm'

;************************************************************
;* PERSIS.ASM -- p-persistence algorithm		    *
;*							    *
;* P-persistence algorithm is based on article		    *
;*	Chepponis, M., Karn, P.:			    *
;*	"The KISS TNC: A simple Host-to-TNC communications  *
;*	 protocol",                                         *
;*	Proc. of the sixth ARRL computer networking conf.   *
;*							    *
;* Copyright (C) 1990 by Jarkko Vuori. All rights reserved. *
;* Author(s): J Vuori					    *
;* Modification(s):					    *
;************************************************************

	section Persistence

	xdef	kickx

	org	p:


;****************************
;* Request to start xmitter *
;****************************
; first check that no carrier is detected
kickx
	move		    #>airfree,x0
	jsr	<tstcar
	jcc	<airfree
	rts

; no carrier, do persistence algorithm
airfree move		    y:<timer,a		    ; first make random number
	move		    x:samples,x0
	add	x0,a	    #>$0000ff,x0
	and	x0,a	    x:<P,x0
	cmp	x0,a				    ; then compare it with P
	jle	<xmton
; we lost random number, wait slottime before trying again
	move		    x:<slotime,a
	move		    #>kickx,x0
	jmp	<delay

; we've won with the random number generator, keyup TX and start Txdelay timer
xmton	jsr	<xmiton
	move		    x:<txdly,a
	move		    #>stxmit,x0
	jmp	<delay


	endsec

	end
