	page	132,63,1,1
	opt	rc
	title	'Timer handling'

;************************************************************
;* TIMER.ASM -- System Timer				    *
;*							    *
;* Provides SCI Timer based system timing.		    *
;*							    *
;* This module uses registers as follows:		    *
;*  r4 - general purpose				    *
;*							    *
;* Copyright (C) 1990 by Jarkko Vuori. All rights reserved. *
;* Author(s): J Vuori					    *
;* Modification(s):					    *
;************************************************************

	section Timer
	xdef	delay,sci_tim,timer

	org	p:

	nolist
	include 'ioequlc'
	include 'macros'
	list


;****************************
;*   Timer service request  *
;****************************
; requested time in a (in 1/4800s), subroutine address
; to be started in x0
delay	move		    x0,y:<subadr
	move		    y:<timer,x0
	add	x0,a
	move		    a1,y:<time
	rts


;****************************
;*   SCI timer interrupt    *
;****************************
; interrupt goes here at every 1/4800s
sci_tim
; save registers to be used
	stoab	scit

; increment timer
	move		    y:<timer,a
	move		    #>1,x0
	add	x0,a	    y:<time,x0
	move		    a1,y:<timer

; check if time elapsed
	eor	x0,a
	jne	<scr_end

; yes, call the desired subroutine
	move		    y:<subadr,a
	tst	a	    a,r4		    ; no need to save r4, because timer int is in the lowest level priority
	jeq	<scr_end
	clr	a
	move		    a,y:<subadr
	jsr	(r4)

; restore registers
scr_end rclab	scit
	rti


;****************************
;*	 DATA - AREA	    *
;****************************

	org	y:

timer	ds	1
time	ds	1
subadr	ds	1

	endsec

	end
