;************************************************************
;* TLC32044.ASM -- General Purpose Texas TLC32044 control   *
;*							    *
;* TLC32044 chip is connected to 56001 via SSI. Only 16     *
;* most significant bits are used in communication.	    *
;*							    *
;* Copyright (C) 1990 by Jarkko Vuori. All rights reserved. *
;* Author(s): J Vuori					    *
;* Modification(s):					    *
;************************************************************


; primary communication controls
noadj	equ	%00<<8
retard	equ	%01<<8
advance equ	%10<<8


; output to ssi
outssi	macro	data
	jclr	#m_tde,x:m_sr,*
	movep		    #data,x:m_tx
	endm


; program the Texas A/D & D/A converter chip
pgmtlc	macro	ctrl,tra,tra2,trb
	outssi	$000000 			    ; flush any garbage out
	outssi	$000300 			    ; begin secondary communication
	outssi	((ctrl<<2)|%11)<<8		    ; set control word
	outssi	$000300 			    ; begin secondary communication
	outssi	((tra<<9)|(tra<<2)|%00)<<8	    ; set TA and RA registers
	outssi	$000300 			    ; begin secondary communication
	outssi	((tra2<<9)|(tra2<<2)|%01)<<8	    ; set TA' and RA' registers
	outssi	$000300 			    ; begin secondary communication
	outssi	((trb<<9)|(trb<<2)|%10)<<8	    ; set TB and RB registers
	endm
